/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1beta1

// PodSetApplyConfiguration represents an declarative configuration of the PodSet type for use
// with apply.
type PodSetApplyConfiguration struct {
	PodTemplateRef *ReferenceApplyConfiguration `json:"podTemplateRef,omitempty"`
	Count          *int32                       `json:"count,omitempty"`
}

// PodSetApplyConfiguration constructs an declarative configuration of the PodSet type for use with
// apply.
func PodSet() *PodSetApplyConfiguration {
	return &PodSetApplyConfiguration{}
}

// WithPodTemplateRef sets the PodTemplateRef field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the PodTemplateRef field is set to the value of the last call.
func (b *PodSetApplyConfiguration) WithPodTemplateRef(value *ReferenceApplyConfiguration) *PodSetApplyConfiguration {
	b.PodTemplateRef = value
	return b
}

// WithCount sets the Count field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Count field is set to the value of the last call.
func (b *PodSetApplyConfiguration) WithCount(value int32) *PodSetApplyConfiguration {
	b.Count = &value
	return b
}
