/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"
	json "encoding/json"
	"fmt"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	v1beta1 "k8s.io/autoscaler/cluster-autoscaler/apis/provisioningrequest/autoscaling.x-k8s.io/v1beta1"
	autoscalingxk8siov1beta1 "k8s.io/autoscaler/cluster-autoscaler/apis/provisioningrequest/client/applyconfiguration/autoscaling.x-k8s.io/v1beta1"
	testing "k8s.io/client-go/testing"
)

// FakeProvisioningRequests implements ProvisioningRequestInterface
type FakeProvisioningRequests struct {
	Fake *FakeAutoscalingV1beta1
	ns   string
}

var provisioningrequestsResource = v1beta1.SchemeGroupVersion.WithResource("provisioningrequests")

var provisioningrequestsKind = v1beta1.SchemeGroupVersion.WithKind("ProvisioningRequest")

// Get takes name of the provisioningRequest, and returns the corresponding provisioningRequest object, and an error if there is any.
func (c *FakeProvisioningRequests) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.ProvisioningRequest, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(provisioningrequestsResource, c.ns, name), &v1beta1.ProvisioningRequest{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ProvisioningRequest), err
}

// List takes label and field selectors, and returns the list of ProvisioningRequests that match those selectors.
func (c *FakeProvisioningRequests) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.ProvisioningRequestList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(provisioningrequestsResource, provisioningrequestsKind, c.ns, opts), &v1beta1.ProvisioningRequestList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.ProvisioningRequestList{ListMeta: obj.(*v1beta1.ProvisioningRequestList).ListMeta}
	for _, item := range obj.(*v1beta1.ProvisioningRequestList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested provisioningRequests.
func (c *FakeProvisioningRequests) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(provisioningrequestsResource, c.ns, opts))

}

// Create takes the representation of a provisioningRequest and creates it.  Returns the server's representation of the provisioningRequest, and an error, if there is any.
func (c *FakeProvisioningRequests) Create(ctx context.Context, provisioningRequest *v1beta1.ProvisioningRequest, opts v1.CreateOptions) (result *v1beta1.ProvisioningRequest, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(provisioningrequestsResource, c.ns, provisioningRequest), &v1beta1.ProvisioningRequest{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ProvisioningRequest), err
}

// Update takes the representation of a provisioningRequest and updates it. Returns the server's representation of the provisioningRequest, and an error, if there is any.
func (c *FakeProvisioningRequests) Update(ctx context.Context, provisioningRequest *v1beta1.ProvisioningRequest, opts v1.UpdateOptions) (result *v1beta1.ProvisioningRequest, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(provisioningrequestsResource, c.ns, provisioningRequest), &v1beta1.ProvisioningRequest{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ProvisioningRequest), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeProvisioningRequests) UpdateStatus(ctx context.Context, provisioningRequest *v1beta1.ProvisioningRequest, opts v1.UpdateOptions) (*v1beta1.ProvisioningRequest, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(provisioningrequestsResource, "status", c.ns, provisioningRequest), &v1beta1.ProvisioningRequest{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ProvisioningRequest), err
}

// Delete takes name of the provisioningRequest and deletes it. Returns an error if one occurs.
func (c *FakeProvisioningRequests) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(provisioningrequestsResource, c.ns, name, opts), &v1beta1.ProvisioningRequest{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeProvisioningRequests) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(provisioningrequestsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.ProvisioningRequestList{})
	return err
}

// Patch applies the patch and returns the patched provisioningRequest.
func (c *FakeProvisioningRequests) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.ProvisioningRequest, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(provisioningrequestsResource, c.ns, name, pt, data, subresources...), &v1beta1.ProvisioningRequest{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ProvisioningRequest), err
}

// Apply takes the given apply declarative configuration, applies it and returns the applied provisioningRequest.
func (c *FakeProvisioningRequests) Apply(ctx context.Context, provisioningRequest *autoscalingxk8siov1beta1.ProvisioningRequestApplyConfiguration, opts v1.ApplyOptions) (result *v1beta1.ProvisioningRequest, err error) {
	if provisioningRequest == nil {
		return nil, fmt.Errorf("provisioningRequest provided to Apply must not be nil")
	}
	data, err := json.Marshal(provisioningRequest)
	if err != nil {
		return nil, err
	}
	name := provisioningRequest.Name
	if name == nil {
		return nil, fmt.Errorf("provisioningRequest.Name must be provided to Apply")
	}
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(provisioningrequestsResource, c.ns, *name, types.ApplyPatchType, data), &v1beta1.ProvisioningRequest{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ProvisioningRequest), err
}

// ApplyStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating ApplyStatus().
func (c *FakeProvisioningRequests) ApplyStatus(ctx context.Context, provisioningRequest *autoscalingxk8siov1beta1.ProvisioningRequestApplyConfiguration, opts v1.ApplyOptions) (result *v1beta1.ProvisioningRequest, err error) {
	if provisioningRequest == nil {
		return nil, fmt.Errorf("provisioningRequest provided to Apply must not be nil")
	}
	data, err := json.Marshal(provisioningRequest)
	if err != nil {
		return nil, err
	}
	name := provisioningRequest.Name
	if name == nil {
		return nil, fmt.Errorf("provisioningRequest.Name must be provided to Apply")
	}
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(provisioningrequestsResource, c.ns, *name, types.ApplyPatchType, data, "status"), &v1beta1.ProvisioningRequest{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ProvisioningRequest), err
}
