/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// This file was generated by go generate; DO NOT EDIT

package aws

// InstanceType is spec of EC2 instance
type InstanceType struct {
	InstanceType string
	VCPU         int64
	MemoryMb     int64
	GPU          int64
	Architecture string
}

// StaticListLastUpdateTime is a string declaring the last time the static list was updated.
var StaticListLastUpdateTime = "2024-04-08"

// InstanceTypes is a map of ec2 resources
var InstanceTypes = map[string]*InstanceType{
	"a1.2xlarge": {
		InstanceType: "a1.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"a1.4xlarge": {
		InstanceType: "a1.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"a1.large": {
		InstanceType: "a1.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "arm64",
	},
	"a1.medium": {
		InstanceType: "a1.medium",
		VCPU:         1,
		MemoryMb:     2048,
		GPU:          0,
		Architecture: "arm64",
	},
	"a1.metal": {
		InstanceType: "a1.metal",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"a1.xlarge": {
		InstanceType: "a1.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"c1.medium": {
		InstanceType: "c1.medium",
		VCPU:         2,
		MemoryMb:     1740,
		GPU:          0,
		Architecture: "amd64",
	},
	"c1.xlarge": {
		InstanceType: "c1.xlarge",
		VCPU:         8,
		MemoryMb:     7168,
		GPU:          0,
		Architecture: "amd64",
	},
	"c3.2xlarge": {
		InstanceType: "c3.2xlarge",
		VCPU:         8,
		MemoryMb:     15360,
		GPU:          0,
		Architecture: "amd64",
	},
	"c3.4xlarge": {
		InstanceType: "c3.4xlarge",
		VCPU:         16,
		MemoryMb:     30720,
		GPU:          0,
		Architecture: "amd64",
	},
	"c3.8xlarge": {
		InstanceType: "c3.8xlarge",
		VCPU:         32,
		MemoryMb:     61440,
		GPU:          0,
		Architecture: "amd64",
	},
	"c3.large": {
		InstanceType: "c3.large",
		VCPU:         2,
		MemoryMb:     3840,
		GPU:          0,
		Architecture: "amd64",
	},
	"c3.xlarge": {
		InstanceType: "c3.xlarge",
		VCPU:         4,
		MemoryMb:     7680,
		GPU:          0,
		Architecture: "amd64",
	},
	"c4.2xlarge": {
		InstanceType: "c4.2xlarge",
		VCPU:         8,
		MemoryMb:     15360,
		GPU:          0,
		Architecture: "amd64",
	},
	"c4.4xlarge": {
		InstanceType: "c4.4xlarge",
		VCPU:         16,
		MemoryMb:     30720,
		GPU:          0,
		Architecture: "amd64",
	},
	"c4.8xlarge": {
		InstanceType: "c4.8xlarge",
		VCPU:         36,
		MemoryMb:     61440,
		GPU:          0,
		Architecture: "amd64",
	},
	"c4.large": {
		InstanceType: "c4.large",
		VCPU:         2,
		MemoryMb:     3840,
		GPU:          0,
		Architecture: "amd64",
	},
	"c4.xlarge": {
		InstanceType: "c4.xlarge",
		VCPU:         4,
		MemoryMb:     7680,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5.12xlarge": {
		InstanceType: "c5.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5.18xlarge": {
		InstanceType: "c5.18xlarge",
		VCPU:         72,
		MemoryMb:     147456,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5.24xlarge": {
		InstanceType: "c5.24xlarge",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5.2xlarge": {
		InstanceType: "c5.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5.4xlarge": {
		InstanceType: "c5.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5.9xlarge": {
		InstanceType: "c5.9xlarge",
		VCPU:         36,
		MemoryMb:     73728,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5.large": {
		InstanceType: "c5.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5.metal": {
		InstanceType: "c5.metal",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5.xlarge": {
		InstanceType: "c5.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5a.12xlarge": {
		InstanceType: "c5a.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5a.16xlarge": {
		InstanceType: "c5a.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5a.24xlarge": {
		InstanceType: "c5a.24xlarge",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5a.2xlarge": {
		InstanceType: "c5a.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5a.4xlarge": {
		InstanceType: "c5a.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5a.8xlarge": {
		InstanceType: "c5a.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5a.large": {
		InstanceType: "c5a.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5a.xlarge": {
		InstanceType: "c5a.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5ad.12xlarge": {
		InstanceType: "c5ad.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5ad.16xlarge": {
		InstanceType: "c5ad.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5ad.24xlarge": {
		InstanceType: "c5ad.24xlarge",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5ad.2xlarge": {
		InstanceType: "c5ad.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5ad.4xlarge": {
		InstanceType: "c5ad.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5ad.8xlarge": {
		InstanceType: "c5ad.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5ad.large": {
		InstanceType: "c5ad.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5ad.xlarge": {
		InstanceType: "c5ad.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5d.12xlarge": {
		InstanceType: "c5d.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5d.18xlarge": {
		InstanceType: "c5d.18xlarge",
		VCPU:         72,
		MemoryMb:     147456,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5d.24xlarge": {
		InstanceType: "c5d.24xlarge",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5d.2xlarge": {
		InstanceType: "c5d.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5d.4xlarge": {
		InstanceType: "c5d.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5d.9xlarge": {
		InstanceType: "c5d.9xlarge",
		VCPU:         36,
		MemoryMb:     73728,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5d.large": {
		InstanceType: "c5d.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5d.metal": {
		InstanceType: "c5d.metal",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5d.xlarge": {
		InstanceType: "c5d.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5n.18xlarge": {
		InstanceType: "c5n.18xlarge",
		VCPU:         72,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5n.2xlarge": {
		InstanceType: "c5n.2xlarge",
		VCPU:         8,
		MemoryMb:     21504,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5n.4xlarge": {
		InstanceType: "c5n.4xlarge",
		VCPU:         16,
		MemoryMb:     43008,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5n.9xlarge": {
		InstanceType: "c5n.9xlarge",
		VCPU:         36,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5n.large": {
		InstanceType: "c5n.large",
		VCPU:         2,
		MemoryMb:     5376,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5n.metal": {
		InstanceType: "c5n.metal",
		VCPU:         72,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c5n.xlarge": {
		InstanceType: "c5n.xlarge",
		VCPU:         4,
		MemoryMb:     10752,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6a.12xlarge": {
		InstanceType: "c6a.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6a.16xlarge": {
		InstanceType: "c6a.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6a.24xlarge": {
		InstanceType: "c6a.24xlarge",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6a.2xlarge": {
		InstanceType: "c6a.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6a.32xlarge": {
		InstanceType: "c6a.32xlarge",
		VCPU:         128,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6a.48xlarge": {
		InstanceType: "c6a.48xlarge",
		VCPU:         192,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6a.4xlarge": {
		InstanceType: "c6a.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6a.8xlarge": {
		InstanceType: "c6a.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6a.large": {
		InstanceType: "c6a.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6a.metal": {
		InstanceType: "c6a.metal",
		VCPU:         192,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6a.xlarge": {
		InstanceType: "c6a.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6g.12xlarge": {
		InstanceType: "c6g.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6g.16xlarge": {
		InstanceType: "c6g.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6g.2xlarge": {
		InstanceType: "c6g.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6g.4xlarge": {
		InstanceType: "c6g.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6g.8xlarge": {
		InstanceType: "c6g.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6g.large": {
		InstanceType: "c6g.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6g.medium": {
		InstanceType: "c6g.medium",
		VCPU:         1,
		MemoryMb:     2048,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6g.metal": {
		InstanceType: "c6g.metal",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6g.xlarge": {
		InstanceType: "c6g.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gd.12xlarge": {
		InstanceType: "c6gd.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gd.16xlarge": {
		InstanceType: "c6gd.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gd.2xlarge": {
		InstanceType: "c6gd.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gd.4xlarge": {
		InstanceType: "c6gd.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gd.8xlarge": {
		InstanceType: "c6gd.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gd.large": {
		InstanceType: "c6gd.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gd.medium": {
		InstanceType: "c6gd.medium",
		VCPU:         1,
		MemoryMb:     2048,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gd.metal": {
		InstanceType: "c6gd.metal",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gd.xlarge": {
		InstanceType: "c6gd.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gn.12xlarge": {
		InstanceType: "c6gn.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gn.16xlarge": {
		InstanceType: "c6gn.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gn.2xlarge": {
		InstanceType: "c6gn.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gn.4xlarge": {
		InstanceType: "c6gn.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gn.8xlarge": {
		InstanceType: "c6gn.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gn.large": {
		InstanceType: "c6gn.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gn.medium": {
		InstanceType: "c6gn.medium",
		VCPU:         1,
		MemoryMb:     2048,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6gn.xlarge": {
		InstanceType: "c6gn.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"c6i.12xlarge": {
		InstanceType: "c6i.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6i.16xlarge": {
		InstanceType: "c6i.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6i.24xlarge": {
		InstanceType: "c6i.24xlarge",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6i.2xlarge": {
		InstanceType: "c6i.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6i.32xlarge": {
		InstanceType: "c6i.32xlarge",
		VCPU:         128,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6i.4xlarge": {
		InstanceType: "c6i.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6i.8xlarge": {
		InstanceType: "c6i.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6i.large": {
		InstanceType: "c6i.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6i.metal": {
		InstanceType: "c6i.metal",
		VCPU:         128,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6i.xlarge": {
		InstanceType: "c6i.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6id.12xlarge": {
		InstanceType: "c6id.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6id.16xlarge": {
		InstanceType: "c6id.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6id.24xlarge": {
		InstanceType: "c6id.24xlarge",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6id.2xlarge": {
		InstanceType: "c6id.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6id.32xlarge": {
		InstanceType: "c6id.32xlarge",
		VCPU:         128,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6id.4xlarge": {
		InstanceType: "c6id.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6id.8xlarge": {
		InstanceType: "c6id.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6id.large": {
		InstanceType: "c6id.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6id.metal": {
		InstanceType: "c6id.metal",
		VCPU:         128,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6id.xlarge": {
		InstanceType: "c6id.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6in.12xlarge": {
		InstanceType: "c6in.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6in.16xlarge": {
		InstanceType: "c6in.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6in.24xlarge": {
		InstanceType: "c6in.24xlarge",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6in.2xlarge": {
		InstanceType: "c6in.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6in.32xlarge": {
		InstanceType: "c6in.32xlarge",
		VCPU:         128,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6in.4xlarge": {
		InstanceType: "c6in.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6in.8xlarge": {
		InstanceType: "c6in.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6in.large": {
		InstanceType: "c6in.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6in.metal": {
		InstanceType: "c6in.metal",
		VCPU:         128,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"c6in.xlarge": {
		InstanceType: "c6in.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7a.12xlarge": {
		InstanceType: "c7a.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7a.16xlarge": {
		InstanceType: "c7a.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7a.24xlarge": {
		InstanceType: "c7a.24xlarge",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7a.2xlarge": {
		InstanceType: "c7a.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7a.32xlarge": {
		InstanceType: "c7a.32xlarge",
		VCPU:         128,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7a.48xlarge": {
		InstanceType: "c7a.48xlarge",
		VCPU:         192,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7a.4xlarge": {
		InstanceType: "c7a.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7a.8xlarge": {
		InstanceType: "c7a.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7a.large": {
		InstanceType: "c7a.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7a.medium": {
		InstanceType: "c7a.medium",
		VCPU:         1,
		MemoryMb:     2048,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7a.metal-48xl": {
		InstanceType: "c7a.metal-48xl",
		VCPU:         192,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7a.xlarge": {
		InstanceType: "c7a.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7g.12xlarge": {
		InstanceType: "c7g.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7g.16xlarge": {
		InstanceType: "c7g.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7g.2xlarge": {
		InstanceType: "c7g.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7g.4xlarge": {
		InstanceType: "c7g.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7g.8xlarge": {
		InstanceType: "c7g.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7g.large": {
		InstanceType: "c7g.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7g.medium": {
		InstanceType: "c7g.medium",
		VCPU:         1,
		MemoryMb:     2048,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7g.metal": {
		InstanceType: "c7g.metal",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7g.xlarge": {
		InstanceType: "c7g.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gd.12xlarge": {
		InstanceType: "c7gd.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gd.16xlarge": {
		InstanceType: "c7gd.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gd.2xlarge": {
		InstanceType: "c7gd.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gd.4xlarge": {
		InstanceType: "c7gd.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gd.8xlarge": {
		InstanceType: "c7gd.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gd.large": {
		InstanceType: "c7gd.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gd.medium": {
		InstanceType: "c7gd.medium",
		VCPU:         1,
		MemoryMb:     2048,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gd.xlarge": {
		InstanceType: "c7gd.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gn.12xlarge": {
		InstanceType: "c7gn.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gn.16xlarge": {
		InstanceType: "c7gn.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gn.2xlarge": {
		InstanceType: "c7gn.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gn.4xlarge": {
		InstanceType: "c7gn.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gn.8xlarge": {
		InstanceType: "c7gn.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gn.large": {
		InstanceType: "c7gn.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gn.medium": {
		InstanceType: "c7gn.medium",
		VCPU:         1,
		MemoryMb:     2048,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7gn.xlarge": {
		InstanceType: "c7gn.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"c7i.12xlarge": {
		InstanceType: "c7i.12xlarge",
		VCPU:         48,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7i.16xlarge": {
		InstanceType: "c7i.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7i.24xlarge": {
		InstanceType: "c7i.24xlarge",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7i.2xlarge": {
		InstanceType: "c7i.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7i.48xlarge": {
		InstanceType: "c7i.48xlarge",
		VCPU:         192,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7i.4xlarge": {
		InstanceType: "c7i.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7i.8xlarge": {
		InstanceType: "c7i.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7i.large": {
		InstanceType: "c7i.large",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7i.metal-24xl": {
		InstanceType: "c7i.metal-24xl",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7i.metal-48xl": {
		InstanceType: "c7i.metal-48xl",
		VCPU:         192,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"c7i.xlarge": {
		InstanceType: "c7i.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"d2.2xlarge": {
		InstanceType: "d2.2xlarge",
		VCPU:         8,
		MemoryMb:     62464,
		GPU:          0,
		Architecture: "amd64",
	},
	"d2.4xlarge": {
		InstanceType: "d2.4xlarge",
		VCPU:         16,
		MemoryMb:     124928,
		GPU:          0,
		Architecture: "amd64",
	},
	"d2.8xlarge": {
		InstanceType: "d2.8xlarge",
		VCPU:         36,
		MemoryMb:     249856,
		GPU:          0,
		Architecture: "amd64",
	},
	"d2.xlarge": {
		InstanceType: "d2.xlarge",
		VCPU:         4,
		MemoryMb:     31232,
		GPU:          0,
		Architecture: "amd64",
	},
	"d3.2xlarge": {
		InstanceType: "d3.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"d3.4xlarge": {
		InstanceType: "d3.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"d3.8xlarge": {
		InstanceType: "d3.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"d3.xlarge": {
		InstanceType: "d3.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"d3en.12xlarge": {
		InstanceType: "d3en.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"d3en.2xlarge": {
		InstanceType: "d3en.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"d3en.4xlarge": {
		InstanceType: "d3en.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"d3en.6xlarge": {
		InstanceType: "d3en.6xlarge",
		VCPU:         24,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"d3en.8xlarge": {
		InstanceType: "d3en.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"d3en.xlarge": {
		InstanceType: "d3en.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"dl1.24xlarge": {
		InstanceType: "dl1.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          8,
		Architecture: "amd64",
	},
	"f1.16xlarge": {
		InstanceType: "f1.16xlarge",
		VCPU:         64,
		MemoryMb:     999424,
		GPU:          0,
		Architecture: "amd64",
	},
	"f1.2xlarge": {
		InstanceType: "f1.2xlarge",
		VCPU:         8,
		MemoryMb:     124928,
		GPU:          0,
		Architecture: "amd64",
	},
	"f1.4xlarge": {
		InstanceType: "f1.4xlarge",
		VCPU:         16,
		MemoryMb:     249856,
		GPU:          0,
		Architecture: "amd64",
	},
	"g2.2xlarge": {
		InstanceType: "g2.2xlarge",
		VCPU:         8,
		MemoryMb:     15360,
		GPU:          1,
		Architecture: "amd64",
	},
	"g2.8xlarge": {
		InstanceType: "g2.8xlarge",
		VCPU:         32,
		MemoryMb:     61440,
		GPU:          4,
		Architecture: "amd64",
	},
	"g3.16xlarge": {
		InstanceType: "g3.16xlarge",
		VCPU:         64,
		MemoryMb:     499712,
		GPU:          4,
		Architecture: "amd64",
	},
	"g3.4xlarge": {
		InstanceType: "g3.4xlarge",
		VCPU:         16,
		MemoryMb:     124928,
		GPU:          1,
		Architecture: "amd64",
	},
	"g3.8xlarge": {
		InstanceType: "g3.8xlarge",
		VCPU:         32,
		MemoryMb:     249856,
		GPU:          2,
		Architecture: "amd64",
	},
	"g3s.xlarge": {
		InstanceType: "g3s.xlarge",
		VCPU:         4,
		MemoryMb:     31232,
		GPU:          1,
		Architecture: "amd64",
	},
	"g4ad.16xlarge": {
		InstanceType: "g4ad.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          4,
		Architecture: "amd64",
	},
	"g4ad.2xlarge": {
		InstanceType: "g4ad.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          1,
		Architecture: "amd64",
	},
	"g4ad.4xlarge": {
		InstanceType: "g4ad.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          1,
		Architecture: "amd64",
	},
	"g4ad.8xlarge": {
		InstanceType: "g4ad.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          2,
		Architecture: "amd64",
	},
	"g4ad.xlarge": {
		InstanceType: "g4ad.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          1,
		Architecture: "amd64",
	},
	"g4dn.12xlarge": {
		InstanceType: "g4dn.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          4,
		Architecture: "amd64",
	},
	"g4dn.16xlarge": {
		InstanceType: "g4dn.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          1,
		Architecture: "amd64",
	},
	"g4dn.2xlarge": {
		InstanceType: "g4dn.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          1,
		Architecture: "amd64",
	},
	"g4dn.4xlarge": {
		InstanceType: "g4dn.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          1,
		Architecture: "amd64",
	},
	"g4dn.8xlarge": {
		InstanceType: "g4dn.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          1,
		Architecture: "amd64",
	},
	"g4dn.metal": {
		InstanceType: "g4dn.metal",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          8,
		Architecture: "amd64",
	},
	"g4dn.xlarge": {
		InstanceType: "g4dn.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          1,
		Architecture: "amd64",
	},
	"g5.12xlarge": {
		InstanceType: "g5.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          4,
		Architecture: "amd64",
	},
	"g5.16xlarge": {
		InstanceType: "g5.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          1,
		Architecture: "amd64",
	},
	"g5.24xlarge": {
		InstanceType: "g5.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          4,
		Architecture: "amd64",
	},
	"g5.2xlarge": {
		InstanceType: "g5.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          1,
		Architecture: "amd64",
	},
	"g5.48xlarge": {
		InstanceType: "g5.48xlarge",
		VCPU:         192,
		MemoryMb:     786432,
		GPU:          8,
		Architecture: "amd64",
	},
	"g5.4xlarge": {
		InstanceType: "g5.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          1,
		Architecture: "amd64",
	},
	"g5.8xlarge": {
		InstanceType: "g5.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          1,
		Architecture: "amd64",
	},
	"g5.xlarge": {
		InstanceType: "g5.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          1,
		Architecture: "amd64",
	},
	"g5g.16xlarge": {
		InstanceType: "g5g.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          2,
		Architecture: "arm64",
	},
	"g5g.2xlarge": {
		InstanceType: "g5g.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          1,
		Architecture: "arm64",
	},
	"g5g.4xlarge": {
		InstanceType: "g5g.4xlarge",
		VCPU:         16,
		MemoryMb:     32768,
		GPU:          1,
		Architecture: "arm64",
	},
	"g5g.8xlarge": {
		InstanceType: "g5g.8xlarge",
		VCPU:         32,
		MemoryMb:     65536,
		GPU:          1,
		Architecture: "arm64",
	},
	"g5g.metal": {
		InstanceType: "g5g.metal",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          2,
		Architecture: "arm64",
	},
	"g5g.xlarge": {
		InstanceType: "g5g.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          1,
		Architecture: "arm64",
	},
	"g6.12xlarge": {
		InstanceType: "g6.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          4,
		Architecture: "amd64",
	},
	"g6.16xlarge": {
		InstanceType: "g6.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          1,
		Architecture: "amd64",
	},
	"g6.24xlarge": {
		InstanceType: "g6.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          4,
		Architecture: "amd64",
	},
	"g6.2xlarge": {
		InstanceType: "g6.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          1,
		Architecture: "amd64",
	},
	"g6.48xlarge": {
		InstanceType: "g6.48xlarge",
		VCPU:         192,
		MemoryMb:     786432,
		GPU:          8,
		Architecture: "amd64",
	},
	"g6.4xlarge": {
		InstanceType: "g6.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          1,
		Architecture: "amd64",
	},
	"g6.8xlarge": {
		InstanceType: "g6.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          1,
		Architecture: "amd64",
	},
	"g6.xlarge": {
		InstanceType: "g6.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          1,
		Architecture: "amd64",
	},
	"gr6.4xlarge": {
		InstanceType: "gr6.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          1,
		Architecture: "amd64",
	},
	"gr6.8xlarge": {
		InstanceType: "gr6.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          1,
		Architecture: "amd64",
	},
	"h1.16xlarge": {
		InstanceType: "h1.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"h1.2xlarge": {
		InstanceType: "h1.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"h1.4xlarge": {
		InstanceType: "h1.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"h1.8xlarge": {
		InstanceType: "h1.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"hpc7g.16xlarge": {
		InstanceType: "hpc7g.16xlarge",
		VCPU:         64,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"hpc7g.4xlarge": {
		InstanceType: "hpc7g.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"hpc7g.8xlarge": {
		InstanceType: "hpc7g.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"i2.2xlarge": {
		InstanceType: "i2.2xlarge",
		VCPU:         8,
		MemoryMb:     62464,
		GPU:          0,
		Architecture: "amd64",
	},
	"i2.4xlarge": {
		InstanceType: "i2.4xlarge",
		VCPU:         16,
		MemoryMb:     124928,
		GPU:          0,
		Architecture: "amd64",
	},
	"i2.8xlarge": {
		InstanceType: "i2.8xlarge",
		VCPU:         32,
		MemoryMb:     249856,
		GPU:          0,
		Architecture: "amd64",
	},
	"i2.xlarge": {
		InstanceType: "i2.xlarge",
		VCPU:         4,
		MemoryMb:     31232,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3.16xlarge": {
		InstanceType: "i3.16xlarge",
		VCPU:         64,
		MemoryMb:     499712,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3.2xlarge": {
		InstanceType: "i3.2xlarge",
		VCPU:         8,
		MemoryMb:     62464,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3.4xlarge": {
		InstanceType: "i3.4xlarge",
		VCPU:         16,
		MemoryMb:     124928,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3.8xlarge": {
		InstanceType: "i3.8xlarge",
		VCPU:         32,
		MemoryMb:     249856,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3.large": {
		InstanceType: "i3.large",
		VCPU:         2,
		MemoryMb:     15616,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3.metal": {
		InstanceType: "i3.metal",
		VCPU:         72,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3.xlarge": {
		InstanceType: "i3.xlarge",
		VCPU:         4,
		MemoryMb:     31232,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3en.12xlarge": {
		InstanceType: "i3en.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3en.24xlarge": {
		InstanceType: "i3en.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3en.2xlarge": {
		InstanceType: "i3en.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3en.3xlarge": {
		InstanceType: "i3en.3xlarge",
		VCPU:         12,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3en.6xlarge": {
		InstanceType: "i3en.6xlarge",
		VCPU:         24,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3en.large": {
		InstanceType: "i3en.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3en.metal": {
		InstanceType: "i3en.metal",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"i3en.xlarge": {
		InstanceType: "i3en.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"i4g.16xlarge": {
		InstanceType: "i4g.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "arm64",
	},
	"i4g.2xlarge": {
		InstanceType: "i4g.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"i4g.4xlarge": {
		InstanceType: "i4g.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"i4g.8xlarge": {
		InstanceType: "i4g.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "arm64",
	},
	"i4g.large": {
		InstanceType: "i4g.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"i4g.xlarge": {
		InstanceType: "i4g.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"i4i.12xlarge": {
		InstanceType: "i4i.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"i4i.16xlarge": {
		InstanceType: "i4i.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"i4i.24xlarge": {
		InstanceType: "i4i.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"i4i.2xlarge": {
		InstanceType: "i4i.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"i4i.32xlarge": {
		InstanceType: "i4i.32xlarge",
		VCPU:         128,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"i4i.4xlarge": {
		InstanceType: "i4i.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"i4i.8xlarge": {
		InstanceType: "i4i.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"i4i.large": {
		InstanceType: "i4i.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"i4i.metal": {
		InstanceType: "i4i.metal",
		VCPU:         128,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"i4i.xlarge": {
		InstanceType: "i4i.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"im4gn.16xlarge": {
		InstanceType: "im4gn.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "arm64",
	},
	"im4gn.2xlarge": {
		InstanceType: "im4gn.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"im4gn.4xlarge": {
		InstanceType: "im4gn.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"im4gn.8xlarge": {
		InstanceType: "im4gn.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"im4gn.large": {
		InstanceType: "im4gn.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"im4gn.xlarge": {
		InstanceType: "im4gn.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"inf1.24xlarge": {
		InstanceType: "inf1.24xlarge",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"inf1.2xlarge": {
		InstanceType: "inf1.2xlarge",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"inf1.6xlarge": {
		InstanceType: "inf1.6xlarge",
		VCPU:         24,
		MemoryMb:     49152,
		GPU:          0,
		Architecture: "amd64",
	},
	"inf1.xlarge": {
		InstanceType: "inf1.xlarge",
		VCPU:         4,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"inf2.24xlarge": {
		InstanceType: "inf2.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"inf2.48xlarge": {
		InstanceType: "inf2.48xlarge",
		VCPU:         192,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"inf2.8xlarge": {
		InstanceType: "inf2.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"inf2.xlarge": {
		InstanceType: "inf2.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"is4gen.2xlarge": {
		InstanceType: "is4gen.2xlarge",
		VCPU:         8,
		MemoryMb:     49152,
		GPU:          0,
		Architecture: "arm64",
	},
	"is4gen.4xlarge": {
		InstanceType: "is4gen.4xlarge",
		VCPU:         16,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "arm64",
	},
	"is4gen.8xlarge": {
		InstanceType: "is4gen.8xlarge",
		VCPU:         32,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "arm64",
	},
	"is4gen.large": {
		InstanceType: "is4gen.large",
		VCPU:         2,
		MemoryMb:     12288,
		GPU:          0,
		Architecture: "arm64",
	},
	"is4gen.medium": {
		InstanceType: "is4gen.medium",
		VCPU:         1,
		MemoryMb:     6144,
		GPU:          0,
		Architecture: "arm64",
	},
	"is4gen.xlarge": {
		InstanceType: "is4gen.xlarge",
		VCPU:         4,
		MemoryMb:     24576,
		GPU:          0,
		Architecture: "arm64",
	},
	"m1.large": {
		InstanceType: "m1.large",
		VCPU:         2,
		MemoryMb:     7680,
		GPU:          0,
		Architecture: "amd64",
	},
	"m1.medium": {
		InstanceType: "m1.medium",
		VCPU:         1,
		MemoryMb:     3788,
		GPU:          0,
		Architecture: "amd64",
	},
	"m1.small": {
		InstanceType: "m1.small",
		VCPU:         1,
		MemoryMb:     1740,
		GPU:          0,
		Architecture: "amd64",
	},
	"m1.xlarge": {
		InstanceType: "m1.xlarge",
		VCPU:         4,
		MemoryMb:     15360,
		GPU:          0,
		Architecture: "amd64",
	},
	"m2.2xlarge": {
		InstanceType: "m2.2xlarge",
		VCPU:         4,
		MemoryMb:     35020,
		GPU:          0,
		Architecture: "amd64",
	},
	"m2.4xlarge": {
		InstanceType: "m2.4xlarge",
		VCPU:         8,
		MemoryMb:     70041,
		GPU:          0,
		Architecture: "amd64",
	},
	"m2.xlarge": {
		InstanceType: "m2.xlarge",
		VCPU:         2,
		MemoryMb:     17510,
		GPU:          0,
		Architecture: "amd64",
	},
	"m3.2xlarge": {
		InstanceType: "m3.2xlarge",
		VCPU:         8,
		MemoryMb:     30720,
		GPU:          0,
		Architecture: "amd64",
	},
	"m3.large": {
		InstanceType: "m3.large",
		VCPU:         2,
		MemoryMb:     7680,
		GPU:          0,
		Architecture: "amd64",
	},
	"m3.medium": {
		InstanceType: "m3.medium",
		VCPU:         1,
		MemoryMb:     3840,
		GPU:          0,
		Architecture: "amd64",
	},
	"m3.xlarge": {
		InstanceType: "m3.xlarge",
		VCPU:         4,
		MemoryMb:     15360,
		GPU:          0,
		Architecture: "amd64",
	},
	"m4.10xlarge": {
		InstanceType: "m4.10xlarge",
		VCPU:         40,
		MemoryMb:     163840,
		GPU:          0,
		Architecture: "amd64",
	},
	"m4.16xlarge": {
		InstanceType: "m4.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"m4.2xlarge": {
		InstanceType: "m4.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m4.4xlarge": {
		InstanceType: "m4.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m4.large": {
		InstanceType: "m4.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m4.xlarge": {
		InstanceType: "m4.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5.12xlarge": {
		InstanceType: "m5.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5.16xlarge": {
		InstanceType: "m5.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5.24xlarge": {
		InstanceType: "m5.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5.2xlarge": {
		InstanceType: "m5.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5.4xlarge": {
		InstanceType: "m5.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5.8xlarge": {
		InstanceType: "m5.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5.large": {
		InstanceType: "m5.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5.metal": {
		InstanceType: "m5.metal",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5.xlarge": {
		InstanceType: "m5.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5a.12xlarge": {
		InstanceType: "m5a.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5a.16xlarge": {
		InstanceType: "m5a.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5a.24xlarge": {
		InstanceType: "m5a.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5a.2xlarge": {
		InstanceType: "m5a.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5a.4xlarge": {
		InstanceType: "m5a.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5a.8xlarge": {
		InstanceType: "m5a.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5a.large": {
		InstanceType: "m5a.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5a.xlarge": {
		InstanceType: "m5a.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5ad.12xlarge": {
		InstanceType: "m5ad.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5ad.16xlarge": {
		InstanceType: "m5ad.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5ad.24xlarge": {
		InstanceType: "m5ad.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5ad.2xlarge": {
		InstanceType: "m5ad.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5ad.4xlarge": {
		InstanceType: "m5ad.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5ad.8xlarge": {
		InstanceType: "m5ad.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5ad.large": {
		InstanceType: "m5ad.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5ad.xlarge": {
		InstanceType: "m5ad.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5d.12xlarge": {
		InstanceType: "m5d.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5d.16xlarge": {
		InstanceType: "m5d.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5d.24xlarge": {
		InstanceType: "m5d.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5d.2xlarge": {
		InstanceType: "m5d.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5d.4xlarge": {
		InstanceType: "m5d.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5d.8xlarge": {
		InstanceType: "m5d.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5d.large": {
		InstanceType: "m5d.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5d.metal": {
		InstanceType: "m5d.metal",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5d.xlarge": {
		InstanceType: "m5d.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5dn.12xlarge": {
		InstanceType: "m5dn.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5dn.16xlarge": {
		InstanceType: "m5dn.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5dn.24xlarge": {
		InstanceType: "m5dn.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5dn.2xlarge": {
		InstanceType: "m5dn.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5dn.4xlarge": {
		InstanceType: "m5dn.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5dn.8xlarge": {
		InstanceType: "m5dn.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5dn.large": {
		InstanceType: "m5dn.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5dn.metal": {
		InstanceType: "m5dn.metal",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5dn.xlarge": {
		InstanceType: "m5dn.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5n.12xlarge": {
		InstanceType: "m5n.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5n.16xlarge": {
		InstanceType: "m5n.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5n.24xlarge": {
		InstanceType: "m5n.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5n.2xlarge": {
		InstanceType: "m5n.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5n.4xlarge": {
		InstanceType: "m5n.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5n.8xlarge": {
		InstanceType: "m5n.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5n.large": {
		InstanceType: "m5n.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5n.metal": {
		InstanceType: "m5n.metal",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5n.xlarge": {
		InstanceType: "m5n.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5zn.12xlarge": {
		InstanceType: "m5zn.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5zn.2xlarge": {
		InstanceType: "m5zn.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5zn.3xlarge": {
		InstanceType: "m5zn.3xlarge",
		VCPU:         12,
		MemoryMb:     49152,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5zn.6xlarge": {
		InstanceType: "m5zn.6xlarge",
		VCPU:         24,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5zn.large": {
		InstanceType: "m5zn.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5zn.metal": {
		InstanceType: "m5zn.metal",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m5zn.xlarge": {
		InstanceType: "m5zn.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6a.12xlarge": {
		InstanceType: "m6a.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6a.16xlarge": {
		InstanceType: "m6a.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6a.24xlarge": {
		InstanceType: "m6a.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6a.2xlarge": {
		InstanceType: "m6a.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6a.32xlarge": {
		InstanceType: "m6a.32xlarge",
		VCPU:         128,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6a.48xlarge": {
		InstanceType: "m6a.48xlarge",
		VCPU:         192,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6a.4xlarge": {
		InstanceType: "m6a.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6a.8xlarge": {
		InstanceType: "m6a.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6a.large": {
		InstanceType: "m6a.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6a.metal": {
		InstanceType: "m6a.metal",
		VCPU:         192,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6a.xlarge": {
		InstanceType: "m6a.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6g.12xlarge": {
		InstanceType: "m6g.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6g.16xlarge": {
		InstanceType: "m6g.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6g.2xlarge": {
		InstanceType: "m6g.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6g.4xlarge": {
		InstanceType: "m6g.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6g.8xlarge": {
		InstanceType: "m6g.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6g.large": {
		InstanceType: "m6g.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6g.medium": {
		InstanceType: "m6g.medium",
		VCPU:         1,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6g.metal": {
		InstanceType: "m6g.metal",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6g.xlarge": {
		InstanceType: "m6g.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6gd.12xlarge": {
		InstanceType: "m6gd.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6gd.16xlarge": {
		InstanceType: "m6gd.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6gd.2xlarge": {
		InstanceType: "m6gd.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6gd.4xlarge": {
		InstanceType: "m6gd.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6gd.8xlarge": {
		InstanceType: "m6gd.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6gd.large": {
		InstanceType: "m6gd.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6gd.medium": {
		InstanceType: "m6gd.medium",
		VCPU:         1,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6gd.metal": {
		InstanceType: "m6gd.metal",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6gd.xlarge": {
		InstanceType: "m6gd.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"m6i.12xlarge": {
		InstanceType: "m6i.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6i.16xlarge": {
		InstanceType: "m6i.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6i.24xlarge": {
		InstanceType: "m6i.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6i.2xlarge": {
		InstanceType: "m6i.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6i.32xlarge": {
		InstanceType: "m6i.32xlarge",
		VCPU:         128,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6i.4xlarge": {
		InstanceType: "m6i.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6i.8xlarge": {
		InstanceType: "m6i.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6i.large": {
		InstanceType: "m6i.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6i.metal": {
		InstanceType: "m6i.metal",
		VCPU:         128,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6i.xlarge": {
		InstanceType: "m6i.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6id.12xlarge": {
		InstanceType: "m6id.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6id.16xlarge": {
		InstanceType: "m6id.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6id.24xlarge": {
		InstanceType: "m6id.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6id.2xlarge": {
		InstanceType: "m6id.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6id.32xlarge": {
		InstanceType: "m6id.32xlarge",
		VCPU:         128,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6id.4xlarge": {
		InstanceType: "m6id.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6id.8xlarge": {
		InstanceType: "m6id.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6id.large": {
		InstanceType: "m6id.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6id.metal": {
		InstanceType: "m6id.metal",
		VCPU:         128,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6id.xlarge": {
		InstanceType: "m6id.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6idn.12xlarge": {
		InstanceType: "m6idn.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6idn.16xlarge": {
		InstanceType: "m6idn.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6idn.24xlarge": {
		InstanceType: "m6idn.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6idn.2xlarge": {
		InstanceType: "m6idn.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6idn.32xlarge": {
		InstanceType: "m6idn.32xlarge",
		VCPU:         128,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6idn.4xlarge": {
		InstanceType: "m6idn.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6idn.8xlarge": {
		InstanceType: "m6idn.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6idn.large": {
		InstanceType: "m6idn.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6idn.metal": {
		InstanceType: "m6idn.metal",
		VCPU:         128,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6idn.xlarge": {
		InstanceType: "m6idn.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6in.12xlarge": {
		InstanceType: "m6in.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6in.16xlarge": {
		InstanceType: "m6in.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6in.24xlarge": {
		InstanceType: "m6in.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6in.2xlarge": {
		InstanceType: "m6in.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6in.32xlarge": {
		InstanceType: "m6in.32xlarge",
		VCPU:         128,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6in.4xlarge": {
		InstanceType: "m6in.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6in.8xlarge": {
		InstanceType: "m6in.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6in.large": {
		InstanceType: "m6in.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6in.metal": {
		InstanceType: "m6in.metal",
		VCPU:         128,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"m6in.xlarge": {
		InstanceType: "m6in.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7a.12xlarge": {
		InstanceType: "m7a.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7a.16xlarge": {
		InstanceType: "m7a.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7a.24xlarge": {
		InstanceType: "m7a.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7a.2xlarge": {
		InstanceType: "m7a.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7a.32xlarge": {
		InstanceType: "m7a.32xlarge",
		VCPU:         128,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7a.48xlarge": {
		InstanceType: "m7a.48xlarge",
		VCPU:         192,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7a.4xlarge": {
		InstanceType: "m7a.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7a.8xlarge": {
		InstanceType: "m7a.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7a.large": {
		InstanceType: "m7a.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7a.medium": {
		InstanceType: "m7a.medium",
		VCPU:         1,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7a.metal-48xl": {
		InstanceType: "m7a.metal-48xl",
		VCPU:         192,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7a.xlarge": {
		InstanceType: "m7a.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7g.12xlarge": {
		InstanceType: "m7g.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7g.16xlarge": {
		InstanceType: "m7g.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7g.2xlarge": {
		InstanceType: "m7g.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7g.4xlarge": {
		InstanceType: "m7g.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7g.8xlarge": {
		InstanceType: "m7g.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7g.large": {
		InstanceType: "m7g.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7g.medium": {
		InstanceType: "m7g.medium",
		VCPU:         1,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7g.metal": {
		InstanceType: "m7g.metal",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7g.xlarge": {
		InstanceType: "m7g.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7gd.12xlarge": {
		InstanceType: "m7gd.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7gd.16xlarge": {
		InstanceType: "m7gd.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7gd.2xlarge": {
		InstanceType: "m7gd.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7gd.4xlarge": {
		InstanceType: "m7gd.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7gd.8xlarge": {
		InstanceType: "m7gd.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7gd.large": {
		InstanceType: "m7gd.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7gd.medium": {
		InstanceType: "m7gd.medium",
		VCPU:         1,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7gd.xlarge": {
		InstanceType: "m7gd.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"m7i-flex.2xlarge": {
		InstanceType: "m7i-flex.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i-flex.4xlarge": {
		InstanceType: "m7i-flex.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i-flex.8xlarge": {
		InstanceType: "m7i-flex.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i-flex.large": {
		InstanceType: "m7i-flex.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i-flex.xlarge": {
		InstanceType: "m7i-flex.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i.12xlarge": {
		InstanceType: "m7i.12xlarge",
		VCPU:         48,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i.16xlarge": {
		InstanceType: "m7i.16xlarge",
		VCPU:         64,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i.24xlarge": {
		InstanceType: "m7i.24xlarge",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i.2xlarge": {
		InstanceType: "m7i.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i.48xlarge": {
		InstanceType: "m7i.48xlarge",
		VCPU:         192,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i.4xlarge": {
		InstanceType: "m7i.4xlarge",
		VCPU:         16,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i.8xlarge": {
		InstanceType: "m7i.8xlarge",
		VCPU:         32,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i.large": {
		InstanceType: "m7i.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i.metal-24xl": {
		InstanceType: "m7i.metal-24xl",
		VCPU:         96,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i.metal-48xl": {
		InstanceType: "m7i.metal-48xl",
		VCPU:         192,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"m7i.xlarge": {
		InstanceType: "m7i.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"mac1.metal": {
		InstanceType: "mac1.metal",
		VCPU:         12,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"mac2-m2.metal": {
		InstanceType: "mac2-m2.metal",
		VCPU:         8,
		MemoryMb:     24576,
		GPU:          0,
		Architecture: "amd64",
	},
	"mac2.metal": {
		InstanceType: "mac2.metal",
		VCPU:         8,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"p2.16xlarge": {
		InstanceType: "p2.16xlarge",
		VCPU:         64,
		MemoryMb:     749568,
		GPU:          16,
		Architecture: "amd64",
	},
	"p2.8xlarge": {
		InstanceType: "p2.8xlarge",
		VCPU:         32,
		MemoryMb:     499712,
		GPU:          8,
		Architecture: "amd64",
	},
	"p2.xlarge": {
		InstanceType: "p2.xlarge",
		VCPU:         4,
		MemoryMb:     62464,
		GPU:          1,
		Architecture: "amd64",
	},
	"p3.16xlarge": {
		InstanceType: "p3.16xlarge",
		VCPU:         64,
		MemoryMb:     499712,
		GPU:          8,
		Architecture: "amd64",
	},
	"p3.2xlarge": {
		InstanceType: "p3.2xlarge",
		VCPU:         8,
		MemoryMb:     62464,
		GPU:          1,
		Architecture: "amd64",
	},
	"p3.8xlarge": {
		InstanceType: "p3.8xlarge",
		VCPU:         32,
		MemoryMb:     249856,
		GPU:          4,
		Architecture: "amd64",
	},
	"p3dn.24xlarge": {
		InstanceType: "p3dn.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          8,
		Architecture: "amd64",
	},
	"p4d.24xlarge": {
		InstanceType: "p4d.24xlarge",
		VCPU:         96,
		MemoryMb:     1179648,
		GPU:          8,
		Architecture: "amd64",
	},
	"p4de.24xlarge": {
		InstanceType: "p4de.24xlarge",
		VCPU:         96,
		MemoryMb:     1179648,
		GPU:          8,
		Architecture: "amd64",
	},
	"p5.48xlarge": {
		InstanceType: "p5.48xlarge",
		VCPU:         192,
		MemoryMb:     2097152,
		GPU:          8,
		Architecture: "amd64",
	},
	"r3.2xlarge": {
		InstanceType: "r3.2xlarge",
		VCPU:         8,
		MemoryMb:     62464,
		GPU:          0,
		Architecture: "amd64",
	},
	"r3.4xlarge": {
		InstanceType: "r3.4xlarge",
		VCPU:         16,
		MemoryMb:     124928,
		GPU:          0,
		Architecture: "amd64",
	},
	"r3.8xlarge": {
		InstanceType: "r3.8xlarge",
		VCPU:         32,
		MemoryMb:     249856,
		GPU:          0,
		Architecture: "amd64",
	},
	"r3.large": {
		InstanceType: "r3.large",
		VCPU:         2,
		MemoryMb:     15360,
		GPU:          0,
		Architecture: "amd64",
	},
	"r3.xlarge": {
		InstanceType: "r3.xlarge",
		VCPU:         4,
		MemoryMb:     31232,
		GPU:          0,
		Architecture: "amd64",
	},
	"r4.16xlarge": {
		InstanceType: "r4.16xlarge",
		VCPU:         64,
		MemoryMb:     499712,
		GPU:          0,
		Architecture: "amd64",
	},
	"r4.2xlarge": {
		InstanceType: "r4.2xlarge",
		VCPU:         8,
		MemoryMb:     62464,
		GPU:          0,
		Architecture: "amd64",
	},
	"r4.4xlarge": {
		InstanceType: "r4.4xlarge",
		VCPU:         16,
		MemoryMb:     124928,
		GPU:          0,
		Architecture: "amd64",
	},
	"r4.8xlarge": {
		InstanceType: "r4.8xlarge",
		VCPU:         32,
		MemoryMb:     249856,
		GPU:          0,
		Architecture: "amd64",
	},
	"r4.large": {
		InstanceType: "r4.large",
		VCPU:         2,
		MemoryMb:     15616,
		GPU:          0,
		Architecture: "amd64",
	},
	"r4.xlarge": {
		InstanceType: "r4.xlarge",
		VCPU:         4,
		MemoryMb:     31232,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5.12xlarge": {
		InstanceType: "r5.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5.16xlarge": {
		InstanceType: "r5.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5.24xlarge": {
		InstanceType: "r5.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5.2xlarge": {
		InstanceType: "r5.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5.4xlarge": {
		InstanceType: "r5.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5.8xlarge": {
		InstanceType: "r5.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5.large": {
		InstanceType: "r5.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5.metal": {
		InstanceType: "r5.metal",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5.xlarge": {
		InstanceType: "r5.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5a.12xlarge": {
		InstanceType: "r5a.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5a.16xlarge": {
		InstanceType: "r5a.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5a.24xlarge": {
		InstanceType: "r5a.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5a.2xlarge": {
		InstanceType: "r5a.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5a.4xlarge": {
		InstanceType: "r5a.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5a.8xlarge": {
		InstanceType: "r5a.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5a.large": {
		InstanceType: "r5a.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5a.xlarge": {
		InstanceType: "r5a.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5ad.12xlarge": {
		InstanceType: "r5ad.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5ad.16xlarge": {
		InstanceType: "r5ad.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5ad.24xlarge": {
		InstanceType: "r5ad.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5ad.2xlarge": {
		InstanceType: "r5ad.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5ad.4xlarge": {
		InstanceType: "r5ad.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5ad.8xlarge": {
		InstanceType: "r5ad.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5ad.large": {
		InstanceType: "r5ad.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5ad.xlarge": {
		InstanceType: "r5ad.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5b.12xlarge": {
		InstanceType: "r5b.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5b.16xlarge": {
		InstanceType: "r5b.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5b.24xlarge": {
		InstanceType: "r5b.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5b.2xlarge": {
		InstanceType: "r5b.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5b.4xlarge": {
		InstanceType: "r5b.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5b.8xlarge": {
		InstanceType: "r5b.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5b.large": {
		InstanceType: "r5b.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5b.metal": {
		InstanceType: "r5b.metal",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5b.xlarge": {
		InstanceType: "r5b.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5d.12xlarge": {
		InstanceType: "r5d.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5d.16xlarge": {
		InstanceType: "r5d.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5d.24xlarge": {
		InstanceType: "r5d.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5d.2xlarge": {
		InstanceType: "r5d.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5d.4xlarge": {
		InstanceType: "r5d.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5d.8xlarge": {
		InstanceType: "r5d.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5d.large": {
		InstanceType: "r5d.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5d.metal": {
		InstanceType: "r5d.metal",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5d.xlarge": {
		InstanceType: "r5d.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5dn.12xlarge": {
		InstanceType: "r5dn.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5dn.16xlarge": {
		InstanceType: "r5dn.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5dn.24xlarge": {
		InstanceType: "r5dn.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5dn.2xlarge": {
		InstanceType: "r5dn.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5dn.4xlarge": {
		InstanceType: "r5dn.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5dn.8xlarge": {
		InstanceType: "r5dn.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5dn.large": {
		InstanceType: "r5dn.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5dn.metal": {
		InstanceType: "r5dn.metal",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5dn.xlarge": {
		InstanceType: "r5dn.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5n.12xlarge": {
		InstanceType: "r5n.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5n.16xlarge": {
		InstanceType: "r5n.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5n.24xlarge": {
		InstanceType: "r5n.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5n.2xlarge": {
		InstanceType: "r5n.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5n.4xlarge": {
		InstanceType: "r5n.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5n.8xlarge": {
		InstanceType: "r5n.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5n.large": {
		InstanceType: "r5n.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5n.metal": {
		InstanceType: "r5n.metal",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r5n.xlarge": {
		InstanceType: "r5n.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6a.12xlarge": {
		InstanceType: "r6a.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6a.16xlarge": {
		InstanceType: "r6a.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6a.24xlarge": {
		InstanceType: "r6a.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6a.2xlarge": {
		InstanceType: "r6a.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6a.32xlarge": {
		InstanceType: "r6a.32xlarge",
		VCPU:         128,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6a.48xlarge": {
		InstanceType: "r6a.48xlarge",
		VCPU:         192,
		MemoryMb:     1572864,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6a.4xlarge": {
		InstanceType: "r6a.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6a.8xlarge": {
		InstanceType: "r6a.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6a.large": {
		InstanceType: "r6a.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6a.metal": {
		InstanceType: "r6a.metal",
		VCPU:         192,
		MemoryMb:     1572864,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6a.xlarge": {
		InstanceType: "r6a.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6g.12xlarge": {
		InstanceType: "r6g.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6g.16xlarge": {
		InstanceType: "r6g.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6g.2xlarge": {
		InstanceType: "r6g.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6g.4xlarge": {
		InstanceType: "r6g.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6g.8xlarge": {
		InstanceType: "r6g.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6g.large": {
		InstanceType: "r6g.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6g.medium": {
		InstanceType: "r6g.medium",
		VCPU:         1,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6g.metal": {
		InstanceType: "r6g.metal",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6g.xlarge": {
		InstanceType: "r6g.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6gd.12xlarge": {
		InstanceType: "r6gd.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6gd.16xlarge": {
		InstanceType: "r6gd.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6gd.2xlarge": {
		InstanceType: "r6gd.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6gd.4xlarge": {
		InstanceType: "r6gd.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6gd.8xlarge": {
		InstanceType: "r6gd.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6gd.large": {
		InstanceType: "r6gd.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6gd.medium": {
		InstanceType: "r6gd.medium",
		VCPU:         1,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6gd.metal": {
		InstanceType: "r6gd.metal",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6gd.xlarge": {
		InstanceType: "r6gd.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"r6i.12xlarge": {
		InstanceType: "r6i.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6i.16xlarge": {
		InstanceType: "r6i.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6i.24xlarge": {
		InstanceType: "r6i.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6i.2xlarge": {
		InstanceType: "r6i.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6i.32xlarge": {
		InstanceType: "r6i.32xlarge",
		VCPU:         128,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6i.4xlarge": {
		InstanceType: "r6i.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6i.8xlarge": {
		InstanceType: "r6i.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6i.large": {
		InstanceType: "r6i.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6i.metal": {
		InstanceType: "r6i.metal",
		VCPU:         128,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6i.xlarge": {
		InstanceType: "r6i.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6id.12xlarge": {
		InstanceType: "r6id.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6id.16xlarge": {
		InstanceType: "r6id.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6id.24xlarge": {
		InstanceType: "r6id.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6id.2xlarge": {
		InstanceType: "r6id.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6id.32xlarge": {
		InstanceType: "r6id.32xlarge",
		VCPU:         128,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6id.4xlarge": {
		InstanceType: "r6id.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6id.8xlarge": {
		InstanceType: "r6id.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6id.large": {
		InstanceType: "r6id.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6id.metal": {
		InstanceType: "r6id.metal",
		VCPU:         128,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6id.xlarge": {
		InstanceType: "r6id.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6idn.12xlarge": {
		InstanceType: "r6idn.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6idn.16xlarge": {
		InstanceType: "r6idn.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6idn.24xlarge": {
		InstanceType: "r6idn.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6idn.2xlarge": {
		InstanceType: "r6idn.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6idn.32xlarge": {
		InstanceType: "r6idn.32xlarge",
		VCPU:         128,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6idn.4xlarge": {
		InstanceType: "r6idn.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6idn.8xlarge": {
		InstanceType: "r6idn.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6idn.large": {
		InstanceType: "r6idn.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6idn.metal": {
		InstanceType: "r6idn.metal",
		VCPU:         128,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6idn.xlarge": {
		InstanceType: "r6idn.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6in.12xlarge": {
		InstanceType: "r6in.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6in.16xlarge": {
		InstanceType: "r6in.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6in.24xlarge": {
		InstanceType: "r6in.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6in.2xlarge": {
		InstanceType: "r6in.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6in.32xlarge": {
		InstanceType: "r6in.32xlarge",
		VCPU:         128,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6in.4xlarge": {
		InstanceType: "r6in.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6in.8xlarge": {
		InstanceType: "r6in.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6in.large": {
		InstanceType: "r6in.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6in.metal": {
		InstanceType: "r6in.metal",
		VCPU:         128,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"r6in.xlarge": {
		InstanceType: "r6in.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7a.12xlarge": {
		InstanceType: "r7a.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7a.16xlarge": {
		InstanceType: "r7a.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7a.24xlarge": {
		InstanceType: "r7a.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7a.2xlarge": {
		InstanceType: "r7a.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7a.32xlarge": {
		InstanceType: "r7a.32xlarge",
		VCPU:         128,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7a.48xlarge": {
		InstanceType: "r7a.48xlarge",
		VCPU:         192,
		MemoryMb:     1572864,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7a.4xlarge": {
		InstanceType: "r7a.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7a.8xlarge": {
		InstanceType: "r7a.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7a.large": {
		InstanceType: "r7a.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7a.medium": {
		InstanceType: "r7a.medium",
		VCPU:         1,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7a.metal-48xl": {
		InstanceType: "r7a.metal-48xl",
		VCPU:         192,
		MemoryMb:     1572864,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7a.xlarge": {
		InstanceType: "r7a.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7g.12xlarge": {
		InstanceType: "r7g.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7g.16xlarge": {
		InstanceType: "r7g.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7g.2xlarge": {
		InstanceType: "r7g.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7g.4xlarge": {
		InstanceType: "r7g.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7g.8xlarge": {
		InstanceType: "r7g.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7g.large": {
		InstanceType: "r7g.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7g.medium": {
		InstanceType: "r7g.medium",
		VCPU:         1,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7g.metal": {
		InstanceType: "r7g.metal",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7g.xlarge": {
		InstanceType: "r7g.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7gd.12xlarge": {
		InstanceType: "r7gd.12xlarge",
		VCPU:         48,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7gd.16xlarge": {
		InstanceType: "r7gd.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7gd.2xlarge": {
		InstanceType: "r7gd.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7gd.4xlarge": {
		InstanceType: "r7gd.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7gd.8xlarge": {
		InstanceType: "r7gd.8xlarge",
		VCPU:         32,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7gd.large": {
		InstanceType: "r7gd.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7gd.medium": {
		InstanceType: "r7gd.medium",
		VCPU:         1,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7gd.xlarge": {
		InstanceType: "r7gd.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"r7i.12xlarge": {
		InstanceType: "r7i.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7i.16xlarge": {
		InstanceType: "r7i.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7i.24xlarge": {
		InstanceType: "r7i.24xlarge",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7i.2xlarge": {
		InstanceType: "r7i.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7i.48xlarge": {
		InstanceType: "r7i.48xlarge",
		VCPU:         192,
		MemoryMb:     1572864,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7i.4xlarge": {
		InstanceType: "r7i.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7i.8xlarge": {
		InstanceType: "r7i.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7i.large": {
		InstanceType: "r7i.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7i.metal-24xl": {
		InstanceType: "r7i.metal-24xl",
		VCPU:         96,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7i.metal-48xl": {
		InstanceType: "r7i.metal-48xl",
		VCPU:         192,
		MemoryMb:     1572864,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7i.xlarge": {
		InstanceType: "r7i.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7iz.12xlarge": {
		InstanceType: "r7iz.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7iz.16xlarge": {
		InstanceType: "r7iz.16xlarge",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7iz.2xlarge": {
		InstanceType: "r7iz.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7iz.32xlarge": {
		InstanceType: "r7iz.32xlarge",
		VCPU:         128,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7iz.4xlarge": {
		InstanceType: "r7iz.4xlarge",
		VCPU:         16,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7iz.8xlarge": {
		InstanceType: "r7iz.8xlarge",
		VCPU:         32,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7iz.large": {
		InstanceType: "r7iz.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7iz.metal-16xl": {
		InstanceType: "r7iz.metal-16xl",
		VCPU:         64,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7iz.metal-32xl": {
		InstanceType: "r7iz.metal-32xl",
		VCPU:         128,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"r7iz.xlarge": {
		InstanceType: "r7iz.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"t1.micro": {
		InstanceType: "t1.micro",
		VCPU:         1,
		MemoryMb:     627,
		GPU:          0,
		Architecture: "amd64",
	},
	"t2.2xlarge": {
		InstanceType: "t2.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"t2.large": {
		InstanceType: "t2.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"t2.medium": {
		InstanceType: "t2.medium",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "amd64",
	},
	"t2.micro": {
		InstanceType: "t2.micro",
		VCPU:         1,
		MemoryMb:     1024,
		GPU:          0,
		Architecture: "amd64",
	},
	"t2.nano": {
		InstanceType: "t2.nano",
		VCPU:         1,
		MemoryMb:     512,
		GPU:          0,
		Architecture: "amd64",
	},
	"t2.small": {
		InstanceType: "t2.small",
		VCPU:         1,
		MemoryMb:     2048,
		GPU:          0,
		Architecture: "amd64",
	},
	"t2.xlarge": {
		InstanceType: "t2.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"t3.2xlarge": {
		InstanceType: "t3.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"t3.large": {
		InstanceType: "t3.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"t3.medium": {
		InstanceType: "t3.medium",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "amd64",
	},
	"t3.micro": {
		InstanceType: "t3.micro",
		VCPU:         2,
		MemoryMb:     1024,
		GPU:          0,
		Architecture: "amd64",
	},
	"t3.nano": {
		InstanceType: "t3.nano",
		VCPU:         2,
		MemoryMb:     512,
		GPU:          0,
		Architecture: "amd64",
	},
	"t3.small": {
		InstanceType: "t3.small",
		VCPU:         2,
		MemoryMb:     2048,
		GPU:          0,
		Architecture: "amd64",
	},
	"t3.xlarge": {
		InstanceType: "t3.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"t3a.2xlarge": {
		InstanceType: "t3a.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"t3a.large": {
		InstanceType: "t3a.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "amd64",
	},
	"t3a.medium": {
		InstanceType: "t3a.medium",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "amd64",
	},
	"t3a.micro": {
		InstanceType: "t3a.micro",
		VCPU:         2,
		MemoryMb:     1024,
		GPU:          0,
		Architecture: "amd64",
	},
	"t3a.nano": {
		InstanceType: "t3a.nano",
		VCPU:         2,
		MemoryMb:     512,
		GPU:          0,
		Architecture: "amd64",
	},
	"t3a.small": {
		InstanceType: "t3a.small",
		VCPU:         2,
		MemoryMb:     2048,
		GPU:          0,
		Architecture: "amd64",
	},
	"t3a.xlarge": {
		InstanceType: "t3a.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"t4g.2xlarge": {
		InstanceType: "t4g.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"t4g.large": {
		InstanceType: "t4g.large",
		VCPU:         2,
		MemoryMb:     8192,
		GPU:          0,
		Architecture: "arm64",
	},
	"t4g.medium": {
		InstanceType: "t4g.medium",
		VCPU:         2,
		MemoryMb:     4096,
		GPU:          0,
		Architecture: "arm64",
	},
	"t4g.micro": {
		InstanceType: "t4g.micro",
		VCPU:         2,
		MemoryMb:     1024,
		GPU:          0,
		Architecture: "arm64",
	},
	"t4g.nano": {
		InstanceType: "t4g.nano",
		VCPU:         2,
		MemoryMb:     512,
		GPU:          0,
		Architecture: "arm64",
	},
	"t4g.small": {
		InstanceType: "t4g.small",
		VCPU:         2,
		MemoryMb:     2048,
		GPU:          0,
		Architecture: "arm64",
	},
	"t4g.xlarge": {
		InstanceType: "t4g.xlarge",
		VCPU:         4,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"trn1.2xlarge": {
		InstanceType: "trn1.2xlarge",
		VCPU:         8,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
	"trn1.32xlarge": {
		InstanceType: "trn1.32xlarge",
		VCPU:         128,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"trn1n.32xlarge": {
		InstanceType: "trn1n.32xlarge",
		VCPU:         128,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"u-12tb1.112xlarge": {
		InstanceType: "u-12tb1.112xlarge",
		VCPU:         448,
		MemoryMb:     12582912,
		GPU:          0,
		Architecture: "amd64",
	},
	"u-18tb1.112xlarge": {
		InstanceType: "u-18tb1.112xlarge",
		VCPU:         448,
		MemoryMb:     18874368,
		GPU:          0,
		Architecture: "amd64",
	},
	"u-24tb1.112xlarge": {
		InstanceType: "u-24tb1.112xlarge",
		VCPU:         448,
		MemoryMb:     25165824,
		GPU:          0,
		Architecture: "amd64",
	},
	"u-3tb1.56xlarge": {
		InstanceType: "u-3tb1.56xlarge",
		VCPU:         224,
		MemoryMb:     3145728,
		GPU:          0,
		Architecture: "amd64",
	},
	"u-6tb1.112xlarge": {
		InstanceType: "u-6tb1.112xlarge",
		VCPU:         448,
		MemoryMb:     6291456,
		GPU:          0,
		Architecture: "amd64",
	},
	"u-6tb1.56xlarge": {
		InstanceType: "u-6tb1.56xlarge",
		VCPU:         224,
		MemoryMb:     6291456,
		GPU:          0,
		Architecture: "amd64",
	},
	"u-9tb1.112xlarge": {
		InstanceType: "u-9tb1.112xlarge",
		VCPU:         448,
		MemoryMb:     9437184,
		GPU:          0,
		Architecture: "amd64",
	},
	"vt1.24xlarge": {
		InstanceType: "vt1.24xlarge",
		VCPU:         96,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"vt1.3xlarge": {
		InstanceType: "vt1.3xlarge",
		VCPU:         12,
		MemoryMb:     24576,
		GPU:          0,
		Architecture: "amd64",
	},
	"vt1.6xlarge": {
		InstanceType: "vt1.6xlarge",
		VCPU:         24,
		MemoryMb:     49152,
		GPU:          0,
		Architecture: "amd64",
	},
	"x1.16xlarge": {
		InstanceType: "x1.16xlarge",
		VCPU:         64,
		MemoryMb:     999424,
		GPU:          0,
		Architecture: "amd64",
	},
	"x1.32xlarge": {
		InstanceType: "x1.32xlarge",
		VCPU:         128,
		MemoryMb:     1998848,
		GPU:          0,
		Architecture: "amd64",
	},
	"x1e.16xlarge": {
		InstanceType: "x1e.16xlarge",
		VCPU:         64,
		MemoryMb:     1998848,
		GPU:          0,
		Architecture: "amd64",
	},
	"x1e.2xlarge": {
		InstanceType: "x1e.2xlarge",
		VCPU:         8,
		MemoryMb:     249856,
		GPU:          0,
		Architecture: "amd64",
	},
	"x1e.32xlarge": {
		InstanceType: "x1e.32xlarge",
		VCPU:         128,
		MemoryMb:     3997696,
		GPU:          0,
		Architecture: "amd64",
	},
	"x1e.4xlarge": {
		InstanceType: "x1e.4xlarge",
		VCPU:         16,
		MemoryMb:     499712,
		GPU:          0,
		Architecture: "amd64",
	},
	"x1e.8xlarge": {
		InstanceType: "x1e.8xlarge",
		VCPU:         32,
		MemoryMb:     999424,
		GPU:          0,
		Architecture: "amd64",
	},
	"x1e.xlarge": {
		InstanceType: "x1e.xlarge",
		VCPU:         4,
		MemoryMb:     124928,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2gd.12xlarge": {
		InstanceType: "x2gd.12xlarge",
		VCPU:         48,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "arm64",
	},
	"x2gd.16xlarge": {
		InstanceType: "x2gd.16xlarge",
		VCPU:         64,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "arm64",
	},
	"x2gd.2xlarge": {
		InstanceType: "x2gd.2xlarge",
		VCPU:         8,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "arm64",
	},
	"x2gd.4xlarge": {
		InstanceType: "x2gd.4xlarge",
		VCPU:         16,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "arm64",
	},
	"x2gd.8xlarge": {
		InstanceType: "x2gd.8xlarge",
		VCPU:         32,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "arm64",
	},
	"x2gd.large": {
		InstanceType: "x2gd.large",
		VCPU:         2,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "arm64",
	},
	"x2gd.medium": {
		InstanceType: "x2gd.medium",
		VCPU:         1,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "arm64",
	},
	"x2gd.metal": {
		InstanceType: "x2gd.metal",
		VCPU:         64,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "arm64",
	},
	"x2gd.xlarge": {
		InstanceType: "x2gd.xlarge",
		VCPU:         4,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "arm64",
	},
	"x2idn.16xlarge": {
		InstanceType: "x2idn.16xlarge",
		VCPU:         64,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2idn.24xlarge": {
		InstanceType: "x2idn.24xlarge",
		VCPU:         96,
		MemoryMb:     1572864,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2idn.32xlarge": {
		InstanceType: "x2idn.32xlarge",
		VCPU:         128,
		MemoryMb:     2097152,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2idn.metal": {
		InstanceType: "x2idn.metal",
		VCPU:         128,
		MemoryMb:     2097152,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2iedn.16xlarge": {
		InstanceType: "x2iedn.16xlarge",
		VCPU:         64,
		MemoryMb:     2097152,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2iedn.24xlarge": {
		InstanceType: "x2iedn.24xlarge",
		VCPU:         96,
		MemoryMb:     3145728,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2iedn.2xlarge": {
		InstanceType: "x2iedn.2xlarge",
		VCPU:         8,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2iedn.32xlarge": {
		InstanceType: "x2iedn.32xlarge",
		VCPU:         128,
		MemoryMb:     4194304,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2iedn.4xlarge": {
		InstanceType: "x2iedn.4xlarge",
		VCPU:         16,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2iedn.8xlarge": {
		InstanceType: "x2iedn.8xlarge",
		VCPU:         32,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2iedn.metal": {
		InstanceType: "x2iedn.metal",
		VCPU:         128,
		MemoryMb:     4194304,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2iedn.xlarge": {
		InstanceType: "x2iedn.xlarge",
		VCPU:         4,
		MemoryMb:     131072,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2iezn.12xlarge": {
		InstanceType: "x2iezn.12xlarge",
		VCPU:         48,
		MemoryMb:     1572864,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2iezn.2xlarge": {
		InstanceType: "x2iezn.2xlarge",
		VCPU:         8,
		MemoryMb:     262144,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2iezn.4xlarge": {
		InstanceType: "x2iezn.4xlarge",
		VCPU:         16,
		MemoryMb:     524288,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2iezn.6xlarge": {
		InstanceType: "x2iezn.6xlarge",
		VCPU:         24,
		MemoryMb:     786432,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2iezn.8xlarge": {
		InstanceType: "x2iezn.8xlarge",
		VCPU:         32,
		MemoryMb:     1048576,
		GPU:          0,
		Architecture: "amd64",
	},
	"x2iezn.metal": {
		InstanceType: "x2iezn.metal",
		VCPU:         48,
		MemoryMb:     1572864,
		GPU:          0,
		Architecture: "amd64",
	},
	"z1d.12xlarge": {
		InstanceType: "z1d.12xlarge",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"z1d.2xlarge": {
		InstanceType: "z1d.2xlarge",
		VCPU:         8,
		MemoryMb:     65536,
		GPU:          0,
		Architecture: "amd64",
	},
	"z1d.3xlarge": {
		InstanceType: "z1d.3xlarge",
		VCPU:         12,
		MemoryMb:     98304,
		GPU:          0,
		Architecture: "amd64",
	},
	"z1d.6xlarge": {
		InstanceType: "z1d.6xlarge",
		VCPU:         24,
		MemoryMb:     196608,
		GPU:          0,
		Architecture: "amd64",
	},
	"z1d.large": {
		InstanceType: "z1d.large",
		VCPU:         2,
		MemoryMb:     16384,
		GPU:          0,
		Architecture: "amd64",
	},
	"z1d.metal": {
		InstanceType: "z1d.metal",
		VCPU:         48,
		MemoryMb:     393216,
		GPU:          0,
		Architecture: "amd64",
	},
	"z1d.xlarge": {
		InstanceType: "z1d.xlarge",
		VCPU:         4,
		MemoryMb:     32768,
		GPU:          0,
		Architecture: "amd64",
	},
}
