// Code generated by volcengine with private/model/cli/gen-api/main.go. DO NOT EDIT.

package autoscaling

import (
	"k8s.io/autoscaler/cluster-autoscaler/cloudprovider/volcengine/volcengine-go-sdk/volcengine"
	"k8s.io/autoscaler/cluster-autoscaler/cloudprovider/volcengine/volcengine-go-sdk/volcengine/request"
	"k8s.io/autoscaler/cluster-autoscaler/cloudprovider/volcengine/volcengine-go-sdk/volcengine/response"
	"k8s.io/autoscaler/cluster-autoscaler/cloudprovider/volcengine/volcengine-go-sdk/volcengine/volcengineutil"
)

const opEnableScalingConfigurationCommon = "EnableScalingConfiguration"

// EnableScalingConfigurationCommonRequest generates a "volcengine/request.Request" representing the
// client's request for the EnableScalingConfigurationCommon operation. The "output" return
// value will be populated with the EnableScalingConfigurationCommon request's response once the request completes
// successfully.
//
// Use "Send" method on the returned EnableScalingConfigurationCommon Request to send the API call to the service.
// the "output" return value is not valid until after EnableScalingConfigurationCommon Send returns without error.
//
// See EnableScalingConfigurationCommon for more information on using the EnableScalingConfigurationCommon
// API call, and error handling.
//
//	// Example sending a request using the EnableScalingConfigurationCommonRequest method.
//	req, resp := client.EnableScalingConfigurationCommonRequest(params)
//
//	err := req.Send()
//	if err == nil { // resp is now filled
//	    fmt.Println(resp)
//	}
func (c *AUTOSCALING) EnableScalingConfigurationCommonRequest(input *map[string]interface{}) (req *request.Request, output *map[string]interface{}) {
	op := &request.Operation{
		Name:       opEnableScalingConfigurationCommon,
		HTTPMethod: "GET",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &map[string]interface{}{}
	}

	output = &map[string]interface{}{}
	req = c.newRequest(op, input, output)

	return
}

// EnableScalingConfigurationCommon API operation for AUTO_SCALING.
//
// Returns volcengineerr.Error for service API and SDK errors. Use runtime type assertions
// with volcengineerr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the VOLCENGINE API reference guide for AUTO_SCALING's
// API operation EnableScalingConfigurationCommon for usage and error information.
func (c *AUTOSCALING) EnableScalingConfigurationCommon(input *map[string]interface{}) (*map[string]interface{}, error) {
	req, out := c.EnableScalingConfigurationCommonRequest(input)
	return out, req.Send()
}

// EnableScalingConfigurationCommonWithContext is the same as EnableScalingConfigurationCommon with the addition of
// the ability to pass a context and additional request options.
//
// See EnableScalingConfigurationCommon for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If the context is nil a panic will occur.
// In the future the SDK may create sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *AUTOSCALING) EnableScalingConfigurationCommonWithContext(ctx volcengine.Context, input *map[string]interface{}, opts ...request.Option) (*map[string]interface{}, error) {
	req, out := c.EnableScalingConfigurationCommonRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opEnableScalingConfiguration = "EnableScalingConfiguration"

// EnableScalingConfigurationRequest generates a "volcengine/request.Request" representing the
// client's request for the EnableScalingConfiguration operation. The "output" return
// value will be populated with the EnableScalingConfigurationCommon request's response once the request completes
// successfully.
//
// Use "Send" method on the returned EnableScalingConfigurationCommon Request to send the API call to the service.
// the "output" return value is not valid until after EnableScalingConfigurationCommon Send returns without error.
//
// See EnableScalingConfiguration for more information on using the EnableScalingConfiguration
// API call, and error handling.
//
//	// Example sending a request using the EnableScalingConfigurationRequest method.
//	req, resp := client.EnableScalingConfigurationRequest(params)
//
//	err := req.Send()
//	if err == nil { // resp is now filled
//	    fmt.Println(resp)
//	}
func (c *AUTOSCALING) EnableScalingConfigurationRequest(input *EnableScalingConfigurationInput) (req *request.Request, output *EnableScalingConfigurationOutput) {
	op := &request.Operation{
		Name:       opEnableScalingConfiguration,
		HTTPMethod: "GET",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &EnableScalingConfigurationInput{}
	}

	output = &EnableScalingConfigurationOutput{}
	req = c.newRequest(op, input, output)

	return
}

// EnableScalingConfiguration API operation for AUTO_SCALING.
//
// Returns volcengineerr.Error for service API and SDK errors. Use runtime type assertions
// with volcengineerr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the VOLCENGINE API reference guide for AUTO_SCALING's
// API operation EnableScalingConfiguration for usage and error information.
func (c *AUTOSCALING) EnableScalingConfiguration(input *EnableScalingConfigurationInput) (*EnableScalingConfigurationOutput, error) {
	req, out := c.EnableScalingConfigurationRequest(input)
	return out, req.Send()
}

// EnableScalingConfigurationWithContext is the same as EnableScalingConfiguration with the addition of
// the ability to pass a context and additional request options.
//
// See EnableScalingConfiguration for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. Ifthe context is nil a panic will occur.
// In the future the SDK may create sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *AUTOSCALING) EnableScalingConfigurationWithContext(ctx volcengine.Context, input *EnableScalingConfigurationInput, opts ...request.Option) (*EnableScalingConfigurationOutput, error) {
	req, out := c.EnableScalingConfigurationRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

type EnableScalingConfigurationInput struct {
	_ struct{} `type:"structure"`

	ScalingConfigurationId *string `type:"string"`

	ScalingGroupId *string `type:"string"`
}

// String returns the string representation
func (s EnableScalingConfigurationInput) String() string {
	return volcengineutil.Prettify(s)
}

// GoString returns the string representation
func (s EnableScalingConfigurationInput) GoString() string {
	return s.String()
}

// SetScalingConfigurationId sets the ScalingConfigurationId field's value.
func (s *EnableScalingConfigurationInput) SetScalingConfigurationId(v string) *EnableScalingConfigurationInput {
	s.ScalingConfigurationId = &v
	return s
}

// SetScalingGroupId sets the ScalingGroupId field's value.
func (s *EnableScalingConfigurationInput) SetScalingGroupId(v string) *EnableScalingConfigurationInput {
	s.ScalingGroupId = &v
	return s
}

type EnableScalingConfigurationOutput struct {
	_ struct{} `type:"structure"`

	Metadata *response.ResponseMetadata

	ScalingConfigurationId *string `type:"string"`
}

// String returns the string representation
func (s EnableScalingConfigurationOutput) String() string {
	return volcengineutil.Prettify(s)
}

// GoString returns the string representation
func (s EnableScalingConfigurationOutput) GoString() string {
	return s.String()
}

// SetScalingConfigurationId sets the ScalingConfigurationId field's value.
func (s *EnableScalingConfigurationOutput) SetScalingConfigurationId(v string) *EnableScalingConfigurationOutput {
	s.ScalingConfigurationId = &v
	return s
}
